/****************************************************************/
/*                      PacketQueue	                            */
/*                                                              */
/****************************************************************/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.net.*;
import java.io.*;

public class PacketQueue extends JFrame
{
	
	private JLabel jLabel1;
	private JLabel jLabel2;
	private JTextArea jTextArea1;
	private JScrollPane jScrollPane1;
	private JButton jButton1;
	private JPanel contentPane;
	public int i,j,a,l;
	public long st,flen;
	public float filelength;
	public String filtfr[];
	public String filmer[];
	public char pakch[][];
	public int loss;
	ServerSocket ss;
	ServerSocket ss1;
	Socket so;
	Socket so1;
	

	


	public PacketQueue()
	{
		super();
		initializeComponent();
		

		this.setVisible(true);
		try
		{			
			ss=new ServerSocket(4500);
			ss1=new ServerSocket(4501);
			while(true)
			{
				so=ss.accept();	
				System.out.println("**************Packets Are Arriving From The Source*********");
				jTextArea1.setText("\nPackets Recieving Started");
				jTextArea1.append("\n\n*******************************************************************************************\n\n");
				DataInputStream dis=new DataInputStream(so.getInputStream());
				st=dis.readLong();
				flen=dis.readLong();
				filelength=dis.readInt();
				filtfr=new String[(int)filelength];
				filmer=new String[(int)filelength];
				pakch=new char[1000][1000];
				for(i=0;i<filelength;i++)
				{
					 filtfr[i]=dis.readUTF();
					 jTextArea1.append("\nRecieved Packet : ["+i+"] = "+filtfr[i]);
					 System.out.println("Packet : ["+i+"] = "+filtfr[i]);
				}
				jTextArea1.append("\n\n*******************************************************************************************\n\n");
				jTextArea1.append("\nPackets Recieving Completed");
				jTextArea1.append("\nPackets Sending Started");
				jTextArea1.append("\n\n*******************************************************************************************\n\n");
				System.out.println("Flen = "+flen);
				System.out.println("Filelength = "+filelength);
				/*for(i=0;i<((int)filelength)-1;i++)
				{
					for(j=0;j<48;j++)
					{
						pakch[i][j]=(char)filtfr[i].charAt(j);
					}
				}
				for(i=0;i<(int)filelength;i++)
				{
					for(j=0;j<48;j++)
					{
						System.out.print(pakch[i][j]+" ");
					}
					System.out.print("\n");
				}
				*/
			l=(int)(Math.random()*filelength);
			
				so1=ss1.accept();	
				DataOutputStream dos=new DataOutputStream(so1.getOutputStream());
				dos.writeLong(st);
				dos.writeLong(flen);
				dos.writeInt((int)filelength);	
				for(i=0;i<filelength;i++)
				{
					if(i==l)
					{

					}
					else
					{
						dos.writeUTF(filtfr[i]);
						jTextArea1.append("\nSending Packet : ["+i+"] = "+filtfr[i]);
					}
				}
				jTextArea1.append("\n\n*******************************************************************************************\n\n");
				jTextArea1.append("\nPackets Sending Completed");
				System.out.println("\nPackets Sending Completed");
			}
		}
		catch(Exception df)
		{
			df.printStackTrace();
		}
	}

	
	private void initializeComponent()
	{
		jLabel1 = new JLabel();
		jLabel1.setFont(new Font("Arial",Font.BOLD,15));
		jLabel1.setForeground(new Color(0, 0, 102));
		jLabel2 = new JLabel();
		jLabel2.setFont(new Font("Arial",Font.BOLD,12));
		jLabel2.setForeground(new Color(0, 0, 102));
		jTextArea1 = new JTextArea();
		jTextArea1.setFont(new Font("Arial",Font.BOLD,12));
		jTextArea1.setForeground(new Color(0, 0, 102));
		jScrollPane1 = new JScrollPane();
		jButton1 = new JButton();
		jButton1.setForeground(new Color(0, 0, 102));
		contentPane = (JPanel)this.getContentPane();

		
		jLabel1.setText("QUEUE");
		
		jLabel2.setText("Status Information");
		
		jScrollPane1.setViewportView(jTextArea1);
		
		jButton1.setText("Exit");
		jButton1.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e)
			{
				jButton1_actionPerformed(e);
			}

		});
		
		contentPane.setLayout(null);
		contentPane.setBackground(new Color(255, 255, 255));
		addComponent(contentPane, jLabel1, 245,14,166,40);
		addComponent(contentPane, jLabel2, 220,70,207,33);
		addComponent(contentPane, jScrollPane1, 23,111,539,387);
		addComponent(contentPane, jButton1, 480,515,83,28);
		
		this.setTitle("PacketQueue");
		this.setLocation(new Point(0, 0));
		this.setSize(new Dimension(590, 580));
		this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	}

	
	private void addComponent(Container container,Component c,int x,int y,int width,int height)
	{
		c.setBounds(x,y,width,height);
		container.add(c);
	}

	
	private void jButton1_actionPerformed(ActionEvent e)
	{
		System.out.println("Exit");
		
		System.exit(1);
	}

	






























 

//============================= Testing ================================//
//=                                                                    =//
//= The following main method is just for testing this class you built.=//
//= After testing,you may simply delete it.                            =//
//======================================================================//
	public static void main(String[] args)
	{
		/*JFrame.setDefaultLookAndFeelDecorated(true);
		JDialog.setDefaultLookAndFeelDecorated(true);
		try
		{
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
		}
		catch (Exception ex)
		{
			System.out.println("Failed loading L&F: ");
			System.out.println(ex);
		}*/
		new PacketQueue();
	}
//= End of Testing =


}
